<template>
  <div
    data-component-group="auth-form"
    data-component="login-form"
  >
    <Form :title="$t('views.login.title')">
      <v-text-field
        v-model="email"
        prepend-inner-icon="mail"
        :label="$t('components.forms.login.email_placeholder')"
        required
        type="email"
        :autofocus="true"
        :error-messages="emailErrors"
        @blur="$v.email.$touch()"
      />
      <v-text-field
        v-model="password"
        prepend-inner-icon="vpn_key"
        :label="$t('components.forms.login.password_placeholder')"
        :append-icon="isPasswordVisible ? 'visibility_off' : 'visibility'"
        required
        :type="isPasswordVisible ? 'text' : 'password'"
        :error-messages="passErrors"
        @blur="$v.password.$touch()"
        @click:append="isPasswordVisible = !isPasswordVisible"
      />

      <div class="form-actions">
        <v-btn
          flat
          class="trigger login"
          :loading="isLoading"
          @click="submit"
        >
          <v-icon small>
            input
          </v-icon>
          {{ 'Login' }}
        </v-btn>
      </div>
    </Form>
  </div>
</template>

<script>
  import { validationMixin } from 'vuelidate';
  import { required, email } from 'vuelidate/lib/validators';
  import colors from 'vuetify/es5/util/colors';
  import Form from '../Form';
  import router from '../../../router';

  export default {
    components: {
      Form,
    },
    mixins: [validationMixin],
    validations: {
      email: {
        required,
        email,
      },
      password: {
        required
      },
    },
    data: () => ({
      email: '',
      password: '',
      colors,
      isPasswordVisible: false,
      isSubmitted: false,
      isLoading: false
    }),
    computed: {
      emailErrors() {
        const errors = [];
        if (!this.$v.email.$dirty) {
          return errors;
        }
        if (!this.$v.email.required) {
          errors.push('Email is required');
        }
        if (!this.$v.email.email) {
          errors.push('Must be valid email');
        }
        return errors;
      },
      passErrors() {
        const errors = [];
        if (!this.$v.password.$dirty) {
          return errors;
        }
        if (!this.$v.password.required) {
          errors.push(router.app.$t('components.forms.login.errors.password_required'));
        }
        return errors;
      },
    },
    created() {
      this.$store.watch(() => {
        const hasErrors = this.$store.getters['alerts/error'].length > 0;

        if (this.isSubmitted && hasErrors) {
          this.isSubmitted = false;
          this.isLoading = false;
        }
      }, () => {});
    },
    methods: {
      submit() {
        this.$v.$touch();

        if (!this.canSubmitRequest() || this.$v.$error || this.$v.pending) {
          return false;
        }
        this.sendLoginRequest();
      },
      clear() {
        this.$v.$reset();
        this.email = '';
        this.password = '';
        this.isSubmitted = false;
      },
      sendLoginRequest() {
        const userAuth = {
          email: this.email.trim(),
          password: this.password,
        };

        this.isSubmitted = true;
        this.isLoading = true;
        return this.$store.dispatch('auth/login', userAuth);
      },
      canSubmitRequest() {
        return this.email !== ''
          && this.password !== ''
          && !this.isSubmitted;
      }
    }
  };
</script>

<style lang="stylus" scoped>
  @import '../../../assets/stylus/theme.styl';

  [data-component-group="auth-form"] {
    &[data-component="login-form"] {
      width: 100%;

      .trigger.go-to-reset-pass {
        color: $colors.shades.black;
        background-color: transparent;
        margin-right: $spacing-sm;
        text-transform: none;

        &:before {
          background-color: transparent !important;
        }
      }

      .trigger.login {
        background-color: $colors.grey.darken-3;
      }
    }
  }
</style>
